Unit rss1r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure rss1r(var X1 :Array of Real; var Y1 :Array of Real;
                var N :Integer; DT :Real; var PX :Array of Real;
                var PY :Array of Real; var PXY1 :Array of Real;
                var PXY2 :Array of Real);

implementation

procedure rss1r(var X1 :Array of Real; var Y1 :Array of Real;
                var N :Integer; DT :Real; var PX :Array of Real;
                var PY :Array of Real; var PXY1 :Array of Real;
                var PXY2 :Array of Real);
var
I,IS_,NC :Integer;
A1,A2,B1,B2,G,P,Q,R :Real;
label
_1;
begin
NC := Trunc( N/2+1 );
G := DT/((N)*4.0);
P := 1.0;
FTF1C(X1,Y1,N,1,1,P);
X1[N+0] := X1[0];
Y1[N+0] := Y1[0];
for I:=1 to NC do
 begin
  IS_ := N+2-I;
  Q := X1[I-1];
  R := X1[IS_-1];
  A1 := Q+R;
  B2 := R-Q;
  Q := Y1[I-1];
  R := Y1[IS_-1];
  A2 := Q-R;
  B1 := Q+R;
  PXY1[I-1] := (A1*B1+A2*B2)*G;
  PXY2[I-1] := (A1*B2-A2*B1)*G;
  PY[I-1] := (B1*B1+B2*B2)*G;
_1:
  PX[I-1] := (A1*A1+A2*A2)*G;
 end;
end;

end.
